<%args>
    $crr             => undef
    $cert_identifier => undef
</%args>
<style type="text/css">
<!--
#main tr.highlight_error {
    background: #ff8888;
}
-->
</style>

<h1><% i18nGettext('I18N_OPENXPKI_CLIENT_HTML_MASON_SERVICE_CREATE_CRR_TITLE') %></h1>
<p>
<% i18nGettext('I18N_OPENXPKI_CLIENT_HTML_MASON_SERVICE_CREATE_CRR_DESC') %>
</p>

% # ERRORS
% if (defined $crr && ref $crr->get_errors() eq 'HASH') {
<h2> <% i18nGettext('I18N_OPENXPKI_CLIENT_HTML_MASON_SERVICE_CREATE_CRR_ERRORS_TITLE') %> </h2>
<ul>
%   foreach my $error (keys %{ $crr->get_errors() }) {
        <li><% i18nGettext($crr->get_errors()->{$error}) %></li>
%   }
</ul>
% }
<p>

<& /service/open_form.mhtml,
    'action' => $context->{menu}->get_root()."/service/create_crr/index.html" &>
<input type="hidden" name="cert_identifier" value="<% $cert_identifier %>">

<table>
    <tr<& /service/create_crr/highlight_error.mhtml, crr => $crr, name => 'workflow_type' &>>
        <td><% i18nGettext('I18N_OPENXPKI_CLIENT_HTML_MASON_SERVICE_CREATE_CRR_WORKFLOW_TYPE') %></td>
        <td>
            <& /lib/html/select.mhtml,
                'name'    => "workflow_type",
                'default' => [ $workflow_type ],
                'values'  => [ @wf_types ] &>
        </td>
    </tr>
    <tr<& /service/create_crr/highlight_error.mhtml, crr => $crr, name => 'revocation_reason' &>>
        <td><% i18nGettext('I18N_OPENXPKI_CLIENT_HTML_MASON_SERVICE_CREATE_CRR_REVOCATION_REASON') %></td>
        <td>
            <& /lib/html/select.mhtml,
                'name'    => "revocation_reason",
                'default' => [ $revocation_reason ],
                'values'  => [ @revoc_reasons ] &>
        </td>
    </tr>
    <tr>
        <td><% i18nGettext('I18N_OPENXPKI_CLIENT_HTML_MASON_SERVICE_CREATE_CRR_COMMENT') %></td>
        <td>
            <& /lib/html/input.mhtml,
                'type'    => 'textarea',
                'name'    => "comment",
                'value'   => $comment,
            &>
        </td>
    </tr>
    <tr<& /service/create_crr/highlight_error.mhtml, crr => $crr, name => 'invalidity_date' &>>
        <td><% i18nGettext('I18N_OPENXPKI_CLIENT_HTML_MASON_SERVICE_CREATE_CRR_INVALIDITY_DATE') %></td>
        <td>
            <& /lib/html/select_date.mhtml,
                'prefix'      => 'invalidity_',
                'now_default' => 1,
            &>
        </td>
    </tr>
</table>
<& /service/send_form.mhtml &>
<& /service/close_form.mhtml &>
<dl>

<%init>
    ## define the available workflow types
    use OpenXPKI::Client::HTML::Mason::CRR;
    if (! defined $crr) {
        $crr = OpenXPKI::Client::HTML::Mason::CRR->new({
            workflow_type     => undef,
            revocation_reason => undef,
            comment           => undef,
            cert_identifier   => undef,
            client            => $context->{client},
            ignore_errors      => 1,
        });
    }
    my @wf_types      = $crr->get_possible_wf_types();
    my @revoc_reasons = OpenXPKI::Client::HTML::Mason::CRR->get_possible_revocation_reasons();
    my $workflow_type;
    my $revocation_reason;
    my $comment;
    if (defined $crr) {
        # set the default values
        $workflow_type     = $crr->get_workflow_type();
        $revocation_reason = $crr->get_revocation_reason();
        $comment           = $crr->get_comment();
    }
</%init>

